
Strict

Rem
bbdoc: Blitz3D SDK
End Rem
Module Blitz3D.Blitz3DSDK

ModuleInfo "Version: 1.00"
ModuleInfo "Author: Mark Sibly, Simon Armstrong"
ModuleInfo "License: Blitz3DSDK License"
ModuleInfo "Copyright: Blitz Research Ltd"
ModuleInfo "Modserver: BRL"

ModuleInfo "History: 1.00 Release"
ModuleInfo "History: We have lift off."

?win32

Import "blitz3dsdk.a"

Include "commands.bmx"
Include "keycodes.bmx"

'OnEnd bbEndRuntime

Function ErrorHandler(err:Byte Ptr) "win32"
	Local error$
	If err error=String.fromcstring(err)
	RuntimeError error
End Function

SetBlitz3DDebugCallback(ErrorHandler)

Const BBFALSE=0
Const BBTRUE=1

Const GFX_DEFAULT=0
Const GFX_FULLSCREEN=1
Const GFX_WINDOWED=2
Const GFX_WINDOWEDSCALED=3

Const PROJ_NONE=0
Const PROJ_PERSPECTIVE=1
Const PROJ_ORTHO=2

Const LIGHT_DIRECTIONAL=1
Const LIGHT_POINT=2
Const LIGHT_SPOT=3

Const TX_COLOR=1
Const TX_ALPHA=2
Const TX_MASKED=4
Const TX_MIP=8
Const TX_CLAMPU=16
Const TX_CLAMPV=32
Const TX_SPHERE=64
Const TX_CUBIC=128
Const TX_VRAM=256
Const TX_HIGHCOLOR=512

Const TX_BLEND_NONE=0
Const TX_BLEND_ALPHA=1
Const TX_BLEND_MULT=2
Const TX_BLEND_ADD=3
Const TX_BLEND_DOT3=4
Const TX_BLEND_MULT2=5

Const CUBEFACE_LEFT=0
Const CUBEFACE_FRONT=1
Const CUBEFACE_RIGHT=2
Const CUBEFACE_BACK=3
Const CUBEFACE_TOP=4
Const CUBEFACE_BOTTOM=5

Const CUBEMODE_SPECULAR=1
Const CUBEMODE_DIFFUSE=2
Const CUBEMODE_REFRACTION=3

Const BLEND_NONE=0
Const BLEND_MULTIPLY=1
Const BLEND_ALPHA=2
Const BLEND_ADD=3

Const FX_NONE=0
Const FX_FULLBRIGHT=1
Const FX_VERTEXCOLOR=2
Const FX_FLAT=4
Const FX_NOFOG=8
Const FX_DOUBLESIDED=16
Const FX_VERTEXALPHA=32

Const COLLIDE_SPHERESPHERE=1
Const COLLIDE_SPHEREPOLY=2
Const COLLIDE_SPHEREBOX=3

Const COLLIDE_STOP=1
Const COLLIDE_SLIDE1=2
Const COLLIDE_SLIDE2=3

Const PICK_NONE=0
Const PICK_SPHERE=1
Const PICK_POLY=2
Const PICK_BOX=3

Const ANIM_STOP=0
Const ANIM_LOOP=1
Const ANIM_PINGPONG=2
Const ANIM_ONCE=3

Const SPRITE_TURNXY=1
Const SPRITE_STILL=2
Const SPRITE_ALIGNZ=3
Const SPRITE_TURNY=4

Const PLAYCD_SINGLE=1
Const PLAYCD_LOOP=2
Const PLAYCD_ALL=3

Const MOUSE_BUTTON=1
Const MOUSE_RIGHTBUTTON=2
Const MOUSE_MIDDLEBUTTON=3

Const JOYTYPE_NONE=0
Const JOYTYPE_DIGITAL=1 
Const JOYTYPE_ANALOG=2

Const BBKEY_ESCAPE=1
Const BBKEY_TAB=15
Const BBKEY_SPACE=57
Const BBKEY_RETURN=28
Const BBKEY_LEFTSHIFT=42
Const BBKEY_LEFTCONTROL=29
Const BBKEY_LEFTALT=56
Const BBKEY_RIGHTSHIFT=54
Const BBKEY_RIGHTCONTROL=157
Const BBKEY_RIGHTALT=184
 
Const BBKEY_UP=200
Const BBKEY_LEFT=203
Const BBKEY_RIGHT=205
Const BBKEY_DOWN=208
 
Const BBKEY_F1=59
Const BBKEY_F2=60  
Const BBKEY_F3=61
Const BBKEY_F4=62
Const BBKEY_F5=63
Const BBKEY_F6=64
Const BBKEY_F7=65
Const BBKEY_F8=66
Const BBKEY_F9=67
Const BBKEY_F10=68

Const BBKEY_Q=16
Const BBKEY_W=17
Const BBKEY_E=18
Const BBKEY_R=19
Const BBKEY_T=20
Const BBKEY_Y=21
Const BBKEY_U=22
Const BBKEY_I=23
Const BBKEY_O=24
Const BBKEY_P=25
 
Const BBKEY_A=30  
Const BBKEY_S=31
Const BBKEY_D=32
Const BBKEY_F=33
Const BBKEY_G=34
Const BBKEY_H=35
Const BBKEY_J=36
Const BBKEY_K=37
Const BBKEY_L=38
 
Const BBKEY_Z=44
Const BBKEY_X=45
Const BBKEY_C=46
Const BBKEY_V=47
Const BBKEY_B=48
Const BBKEY_N=49
Const BBKEY_M=50  
 
Const BBKEY_1=2
Const BBKEY_2=3
Const BBKEY_3=4
Const BBKEY_4=5
Const BBKEY_5=6
Const BBKEY_6=7
Const BBKEY_7=8
Const BBKEY_8=9
Const BBKEY_9=10   
Const BBKEY_0=11

Const BBKEY_MINUS=12
Const BBKEY_EQUALS=13
Const BBKEY_BACKSPACE=14
Const BBKEY_LEFTBRACKET=26
Const BBKEY_RIGHTBRACKET=27
Const BBKEY_SEMICOLON=39
Const BBKEY_APOSTROPHE=40   
Const BBKEY_GRAVE=41
Const BBKEY_BACKSLASH=43
Const BBKEY_COMMA=51
Const BBKEY_PERIOD=52
Const BBKEY_SLASH=53
Const BBKEY_CAPSLOCK=58
 
Const BBKEY_PRINT=183
Const BBKEY_SCROLLLOCK=70   
Const BBKEY_PAUSEBREAK=197
Const BBKEY_INSERT=210
Const BBKEY_DELETE=211
Const BBKEY_HOME=199
Const BBKEY_END=207
Const BBKEY_PAGEUP=201
Const BBKEY_PAGEDOWN=209

Const BBKEY_NUMLOCK=69
Const BBKEY_NUMPADDIVIDE=181
Const BBKEY_NUMPADMULT=55
Const BBKEY_NUMPADMINUS=74
Const BBKEY_NUMPADPLUS=78
Const BBKEY_NUMPADENTER=156
Const BBKEY_NUMPADDOT=83
Const BBKEY_NUMPAD0=82
Const BBKEY_NUMPAD1=79
Const BBKEY_NUMPAD2=80  
Const BBKEY_NUMPAD3=81
Const BBKEY_NUMPAD4=75
Const BBKEY_NUMPAD5=76
Const BBKEY_NUMPAD6=77
Const BBKEY_NUMPAD7=71
Const BBKEY_NUMPAD8=72
Const BBKEY_NUMPAD9=73

Const BBKEY_F11=87
Const BBKEY_F12=88
Const BBKEY_LEFTWINDOWS=219
Const BBKEY_RIGHTWINDOWS=220
Const BBKEY_NUMPADEQUALS=141
Const BBKEY_NUMPADCOMMA=179
Const BBKEY_OEM_102=86
Const BBKEY_AT=145
Const BBKEY_COLON=146
Const BBKEY_UNDERLINE=147
Const BBKEY_BREAK=149

Const BBKEY_PREVIOUSTRACK=144
Const BBKEY_NEXTTRACK=153
Const BBKEY_MUTE=160
Const BBKEY_PLAYPAUSE=162
Const BBKEY_STOP=164
Const BBKEY_VOLUMELESS=174
Const BBKEY_VOLUMEMORE=176
 
Const BBKEY_APPS=221
Const BBKEY_POWER=222
Const BBKEY_SLEEP=223
Const BBKEY_WAKE=227

Const BBKEY_WEBHOME=178
Const BBKEY_WEBSEARCH=229
Const BBKEY_WEBFAVORITES=230   
Const BBKEY_WEBREFRESH=231
Const BBKEY_WEBSTOP=232
Const BBKEY_WEBFORWARD=233
Const BBKEY_WEBBACK=234
 
Const BBKEY_MYCOMPUTER=235
Const BBKEY_CALCULATOR=161
Const BBKEY_MAIL=236
Const BBKEY_MEDIASELECT=237

?
